/**
  ******************************************************************************
  * @file    main.c
  * @author  Ac6
  * @version V1.0
  * @date    01-December-2013
  * @brief   Default main function.
  ******************************************************************************
*/

#include <stdlib.h>
#include "stm32f4xx.h"
#include "stm32f429i_discovery.h"
#include "stm32f429i_discovery_lcd.h"
#include "system_clocks.h"
#include "simpleLCD.h"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define My_Input_Pin GPIO_PIN_8
#define My_Input_Pin_GPIO_Port GPIOC
#define FREQ 4 //Hz
#define PERIOD (1000/FREQ) // ms
/* Private macro -----------------------
 * --------------------------------------*/
/* Private variables ---------------------------------------------------------*/
static GPIO_PinState stateInput, stateOutput;
static GPIO_PinState stateLast = 0;
//static char str[30];

/* Private function prototypes -----------------------------------------------*/
//static void SystemClock_Config(void);
//static void Error_Handler(void);
static void My_GPIO_Init(void);
static void EXTILine0_Config(void);

/* Private functions ---------------------------------------------------------*/

int main(void)
{
  HAL_Init();

  /* Configure LED3 and LED4 */
  BSP_LED_Init(LED3);
  BSP_LED_Init(LED4);

  /* Configure the system clock to 180 MHz */
  SystemClock_Config();

  /* Configure EXTI Line0 (connected to PA0 pin) in interrupt mode */
  EXTILine0_Config();

  My_GPIO_Init();
  LCD_Init();
  LCD_PrintXY(5,7,"Witam !");

  BSP_LED_Off(LED3);
  BSP_LED_Off(LED4);

  /* Infinite loop */
  while(1){
	//stateInput = HAL_GPIO_ReadPin(GPIOC, GPIO_PIN_8); // odczyt stanu bitu PC8
	// wejście można też odczytywac !!
	stateInput = HAL_GPIO_ReadPin(GPIOG, GPIO_PIN_13); // odczyt stanu bitu PG13 czyli LED3 zielona
	// wyznaczenie stanu wyjścia
	stateOutput = stateInput; // powielanie sygnału lub ...
	//if( (!stateLast) && stateInput) stateOutput = !stateOutput;// zbocze rosnące, dzielnik /2
	HAL_GPIO_WritePin(GPIOG, GPIO_PIN_14, stateOutput); // zapis bitu PG14 czyli LED4 czerwona

    BSP_LED_Toggle(LED3); //czyli PG13, jako generator

	HAL_Delay(100);
	stateLast = stateInput;
  }
}
/**
  * @brief  Configures EXTI Line0 (connected to PA0 pin) in interrupt mode
  * @param  None
  * @retval None
  */
static void EXTILine0_Config(void)
{
  GPIO_InitTypeDef   GPIO_InitStructure;

  /* Enable GPIOA clock */
  __HAL_RCC_GPIOA_CLK_ENABLE();

  /* Configure PA0 pin as input floating */
  GPIO_InitStructure.Mode = GPIO_MODE_IT_FALLING;
  GPIO_InitStructure.Pull = GPIO_NOPULL;
  GPIO_InitStructure.Pin = GPIO_PIN_0;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStructure);

  /* Enable and set EXTI Line0 Interrupt to the lowest priority */
  HAL_NVIC_SetPriority(EXTI0_IRQn, 2, 0);
  HAL_NVIC_EnableIRQ(EXTI0_IRQn);
}

void My_GPIO_Init(void){
  GPIO_InitTypeDef  GPIO_InitStruct;

  /* Enable GPIOA clock */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  /*Configure GPIO pin : My_Input_Pin */
  /* Configure PC8 pin as input floating */
  GPIO_InitStruct.Pin = My_Input_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(My_Input_Pin_GPIO_Port, &GPIO_InitStruct);
}

/**
  * @brief EXTI line detection callbacks
  * @param GPIO_Pin: Specifies the pins connected EXTI line
  * @retval None
  */
void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin)
{
  if(GPIO_Pin == KEY_BUTTON_PIN)
  {
    //*** TU wpisz reakcję na przycisk
    // np.
    /* Toggle LED3 */
    //BSP_LED_Toggle(LED3);
  }
}
